#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>

#include <stdio.h>

#define VYSKAW    520
#define SIRKAW    520
#define VYSKAHR    50
#define SIRKAHR    50
#define VYSKABG   128
#define SIRKABG   128
#define SIRKAZP    10
#define SIRKAPP    10
#define SIRKAKP    10
#define VYSKAPAT   10
#define SIRKAPICH  10
#define VYSKAPICH  40
#define MAXPATER   10
#define MEZIPAT    80
#define FPS        50
#define CARU        8

#include "icon.xbm"
#include "pozadi.xpm"
Pixmap pcp;

#include "kmic1.xpm"
#include "kmic2.xpm"
#include "kmic3.xpm"
#include "kmic4.xpm"
Pixmap kmic[4];

#include "rmic1.xpm"
#include "rmic2.xpm"
#include "rmic3.xpm"
#include "rmic4.xpm"
#include "rmic5.xpm"
#include "rmic6.xpm"
#include "rmic7.xpm"
#include "rmic8.xpm"
#include "rmic9.xpm"
#include "rmic10.xpm"
Pixmap rmic[10];

#include "smic1.xpm"
#include "smic2.xpm"
#include "smic3.xpm"
#include "smic4.xpm"
#include "smic5.xpm"
#include "smic6.xpm"
Pixmap smic[6];

struct mypxm{
  Pixmap barvy, akanal;
} zpatro, ppatro, kpatro, pichak, pichaky, dlouhepat;

#include "pmic1.xpm"
#include "pmic2.xpm"
#include "pmic3.xpm"
#include "pmic4.xpm"
#include "pmic5.xpm"
struct mypxm pmic[5];

#include "car1.xpm"
#include "car2.xpm"
#include "car3.xpm"
#include "car4.xpm"
#include "car5.xpm"
#include "car6.xpm"
#include "car7.xpm"
#include "car8.xpm"
struct mypxm car[8];

Pixmap shapehr;

#include "pichak.xpm"
#include "zpatro.xpm"
#include "ppatro.xpm"
#include "kpatro.xpm"

Pixmap icon_pixmap;

Display *display;
int screen;

Window win, whrac, wpich, root, wcar[CARU];
unsigned int depth;

Pixmap pp;                   /* pixmapa pozadi */
int vpp;                     /* vyska pixmapy pozadi */
Window wpoz1, wpoz2;
int posunutip;

GC gc, shape_gc;

int vlevo, vpravo, skok, zastaveno;
XFontStruct *font_info;

#define ODECTICAS ((ncas.tv_sec-ocas.tv_sec)*1000000+ncas.tv_usec-ocas.tv_usec)

Pixmap nactiXPM(char **data, int sirka, int vyska, Pixmap *shape);
struct mypxm nactimyXPM(char **data, int sirka, int vyska);
void jedu();
void vymyslip(Window w);
void udalosti();

struct patro{
  Pixmap barvy, akanal;
  int zacatek, konec, vyska;
} patra1[MAXPATER], patra2[MAXPATER], *pat1, *pat2;
int poslpat, pocetpat1, pocetpat2, pocetpater, prechpat;

void error(char *s) {
  fprintf(stderr, "Error: %s\n", s);
  exit(1);
}

/*
int GetColor(char *s) {
  Colormap cmap;
  XColor c, xc;

  if (!XAllocNamedColor(display, colormap, s, &c, &xc))
    error("Can't allocate colors");
  return(c.pixel);
}

void vytvorhod()
{
  XSizeHints size_hints;
  unsigned int border_width = 4;
  char *window_name = "cas X Icy Toweru";
  char *icon_name = "cas";

  whodiny = XCreateSimpleWindow(display, root,
				0, 0, SIRKAW, VYSKAW, border_width,
				BlackPixel(display,screen),
				BlackPixel(display,screen));
  
  size_hints.flags = PPosition | PSize;
  size_hints.x = 0;
  size_hints.y = 0;
  size_hints.width = SIRKAW;
  size_hints.height = 40;

  XSetStandardProperties(display, whodiny, window_name, icon_name, icon_pixmap,
			 argv, argc, &size_hints);

  XSelectInput(display, whodiny, StructureNotifyMask);

  XMapWindow(display, whodiny);
}
*/

void vytvorcar(x,y,i)
{
  int v;

  v=i/2%2*2+10;
  wcar[i] = XCreateSimpleWindow(display, win,
			    x, y, 22-v, v, 0,
			    BlackPixel(display,screen),
			    WhitePixel(display,screen));

  XShapeCombineMask (display, wcar[i], ShapeBounding,
		     0, 0, car[i].akanal, ShapeSet);

  XSetWindowBackgroundPixmap(display, wcar[i], car[i].barvy);

  XMapWindow(display, wcar[i]);
}

void posuncar(x,y,i){
  XMoveWindow(display, wcar[i], x,y);
}

void zniccar(i)
{
  XDestroyWindow(display, wcar[i]);
}

Pixmap pixpat(struct patro p, Pixmap zpat, Pixmap ppat,
	      Pixmap kpat, unsigned int hloubka)
{
  Pixmap vysledek;
  int zacatek, delka, konec;
  GC togc;

  togc = gc;
  if(hloubka == 1) togc = shape_gc;

  delka = p.konec - p.zacatek;
  vysledek = XCreatePixmap(display, root,
			   delka, VYSKAPAT, hloubka);

  if(p.zacatek == 0) zacatek=0;
  else{
    XCopyArea(display, zpat, vysledek, togc,
	      0, 0,
	      SIRKAZP, VYSKAPAT,
	      0, 0);
    zacatek=SIRKAZP;
  }

  if(p.konec == SIRKAW) konec = 0;
  else{
    XCopyArea(display, kpat, vysledek, togc,
	      0, 0,
	      SIRKAKP, VYSKAPAT,
	      delka-SIRKAKP, 0);
    konec = SIRKAKP;
  }

  XCopyArea(display, ppat, vysledek, togc,
	    0, 0,
	    delka-zacatek-konec, VYSKAPAT,
	    zacatek, 0);

  return vysledek;
}

kreslipat(struct patro p, Window w)
{
  Window wpatro;

  p.barvy = pixpat(p, zpatro.barvy, dlouhepat.barvy, kpatro.barvy, depth);
  p.akanal = pixpat(p, zpatro.akanal, dlouhepat.akanal, kpatro.akanal,1);
  pat2[pocetpat2] = p;

  wpatro =  XCreateSimpleWindow(display, w,
				p.zacatek, vpp - poslpat, p.konec-p.zacatek,
				VYSKAPAT, 0,
				BlackPixel(display,screen),
				WhitePixel(display,screen));

  XShapeCombineMask (display, wpatro, ShapeBounding,
		     0, 0, p.akanal, ShapeSet);

  XSetWindowBackgroundPixmap(display, wpatro, p.barvy);
  XMapWindow(display, wpatro);
}

vyrobpatra(Window w)
{
  struct patro *pompat;

  pocetpater += pocetpat2-prechpat;

  pompat = pat1;
  pat1 = pat2;
  pat2 = pompat;
  pocetpat1 = pocetpat2;
  pocetpat2 = 0;
  prechpat = 0;

  if(w == wpoz1){
    poslpat = VYSKAPICH+VYSKAPAT;
    pocetpater = 0;
  }
  else{
    poslpat -= vpp;
    if(poslpat > MEZIPAT){
      prechpat = 1;
      pocetpat1--;
      poslpat-=MEZIPAT;
      kreslipat(pat1[pocetpat1-1],w);
      poslpat+=MEZIPAT;
      pocetpat2++;
    }
  }

  for(; poslpat<vpp+VYSKAPAT; poslpat += MEZIPAT, pocetpat2++) vymyslip(w);
}

void freepatra()
{
  int i;

  for(i=0; i<pocetpat1+prechpat; i++){
    XFreePixmap(display, pat1[i].barvy);
    XFreePixmap(display, pat1[i].akanal);
  }
}

struct patro ziskejpatro(int cipat)
{
  if(cipat >= pocetpater)
    return pat2[cipat-pocetpater];
  else return pat1[cipat-pocetpater+pocetpat1];
}

long int uzpozdeni;

void timer()
{
  int framu;
  struct timeval tv;

  for(;;){
    udalosti();
    jedu();
    XFlush(display);

    tv.tv_sec = 0;
    tv.tv_usec = 1000000/FPS;
    select(0, NULL, NULL, NULL, &tv);
  }
}

void nactiobry()
{
  pcp     = nactiXPM(pozadi_xpm, SIRKABG, VYSKABG, NULL);
  kmic[0] = nactiXPM(kmic1_xpm,  SIRKAHR, VYSKAHR, &shapehr);
  kmic[1] = nactiXPM(kmic2_xpm,  SIRKAHR, VYSKAHR, NULL);
  kmic[2] = nactiXPM(kmic3_xpm,  SIRKAHR, VYSKAHR, NULL);
  kmic[3] = nactiXPM(kmic4_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[0] = nactiXPM(rmic1_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[1] = nactiXPM(rmic2_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[2] = nactiXPM(rmic3_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[3] = nactiXPM(rmic4_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[4] = nactiXPM(rmic5_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[5] = nactiXPM(rmic6_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[6] = nactiXPM(rmic7_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[7] = nactiXPM(rmic8_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[8] = nactiXPM(rmic9_xpm,  SIRKAHR, VYSKAHR, NULL);
  rmic[9] = nactiXPM(rmic10_xpm, SIRKAHR, VYSKAHR, NULL);
  smic[0] = nactiXPM(smic1_xpm,  SIRKAHR, VYSKAHR, NULL);
  smic[1] = nactiXPM(smic2_xpm,  SIRKAHR, VYSKAHR, NULL);
  smic[2] = nactiXPM(smic3_xpm,  SIRKAHR, VYSKAHR, NULL);
  smic[3] = nactiXPM(smic4_xpm,  SIRKAHR, VYSKAHR, NULL);
  smic[4] = nactiXPM(smic5_xpm,  SIRKAHR, VYSKAHR, NULL);
  smic[5] = nactiXPM(smic6_xpm,  SIRKAHR, VYSKAHR, NULL);

  pmic[0] = nactimyXPM(pmic1_xpm,  SIRKAHR, VYSKAHR);
  pmic[1] = nactimyXPM(pmic2_xpm,  SIRKAHR, VYSKAHR);
  pmic[2] = nactimyXPM(pmic3_xpm,  SIRKAHR, VYSKAHR);
  pmic[3] = nactimyXPM(pmic4_xpm,  SIRKAHR, VYSKAHR);
  pmic[4] = nactimyXPM(pmic5_xpm,  SIRKAHR, VYSKAHR);

  car[0] = nactimyXPM(car1_xpm,  12, 10);
  car[1] = nactimyXPM(car2_xpm,  12, 10);
  car[2] = nactimyXPM(car3_xpm,  10, 12);
  car[3] = nactimyXPM(car4_xpm,  10, 12);
  car[4] = nactimyXPM(car5_xpm,  12, 10);
  car[5] = nactimyXPM(car6_xpm,  12, 10);
  car[6] = nactimyXPM(car7_xpm,  10, 12);
  car[7] = nactimyXPM(car8_xpm,  10, 12);

  pichak =  nactimyXPM(pichak_xpm, SIRKAPICH, VYSKAPICH);
  zpatro  = nactimyXPM(zpatro_xpm, SIRKAZP, VYSKAPAT);
  ppatro  = nactimyXPM(ppatro_xpm, SIRKAPP, VYSKAPAT);
  kpatro  = nactimyXPM(kpatro_xpm, SIRKAKP, VYSKAPAT); 
}

Pixmap nactiXPM(char **data, int sirka, int vyska, Pixmap *shape)
{
  Pixmap pxm, shp;

  if(shape == NULL) shape = &shp;
  pxm = XCreatePixmap(display, root,
		      sirka, vyska, depth);
  XpmCreatePixmapFromData (display, root,
                           data, &pxm, shape,
                           NULL);
  return pxm;
}

struct mypxm nactimyXPM(char **data, int sirka, int vyska)
{
  struct mypxm mpm;

  mpm.barvy = XCreatePixmap(display, root,
			    sirka, vyska, depth);
  XpmCreatePixmapFromData (display, root,
                           data, &(mpm.barvy), &(mpm.akanal),
                           NULL);
  return mpm;
}

void initpich()
{
  int x;

  pichaky.barvy =  XCreatePixmap(display, root,
				 SIRKAW, VYSKAPICH, depth);
  for(x=0; x<SIRKAW; x+=SIRKAPICH)
    XCopyArea(display, pichak.barvy, pichaky.barvy, gc,
	      0, 0,
	      SIRKAPICH, VYSKAPICH,
	      x, 0);

  pichaky.akanal =  XCreatePixmap(display, root,
				 SIRKAW, VYSKAPICH, 1);
  for(x=0; x<SIRKAW; x+=SIRKAPICH)
    XCopyArea(display, pichak.akanal, pichaky.akanal, shape_gc,
	      0, 0,
	      SIRKAPICH, VYSKAPICH,
	      x, 0);
}

void vytvorpich()
{
  initpich();
  wpich = XCreateSimpleWindow(display, win,
			      0, VYSKAW-VYSKAPICH, SIRKAW,
			      VYSKAPICH, 0,
			      BlackPixel(display,screen),
			      WhitePixel(display,screen));
  XShapeCombineMask (display, wpich, ShapeBounding,
		     0, 0, pichaky.akanal, ShapeSet);
  XSetWindowBackgroundPixmap(display, wpich, pichaky.barvy);
  XMapWindow(display, wpich);
}

void initpoz()
{
  int x,y;

  shape_gc = XCreateGC(display, shapehr, 0, NULL);

  vpp = ((VYSKAW-1)/VYSKABG+1)*VYSKABG;

  pp = XCreatePixmap(display, root,
		     SIRKAW, vpp, depth);

  for(x=0; x<SIRKAW; x+=SIRKABG)
    for(y=0; y<vpp; y+=VYSKABG)
      XCopyArea(display, pcp, pp, gc,
		0, 0,
		SIRKABG, VYSKABG,
		x, y);

  dlouhepat.barvy = XCreatePixmap(display, root,
		     SIRKAW, VYSKAPAT, depth);

  for(x=0; x<SIRKAW; x+=SIRKAPP)
    XCopyArea(display, ppatro.barvy, dlouhepat.barvy, gc,
	      0, 0,
	      SIRKAPP, VYSKAPAT,
	      x, 0);
 
  dlouhepat.akanal = XCreatePixmap(display, root,
		     SIRKAW, VYSKAPAT, 1);

  for(x=0; x<SIRKAW; x+=SIRKAPP)
    XCopyArea(display, ppatro.akanal, dlouhepat.akanal, shape_gc,
	      0, 0,
	      SIRKAPP, VYSKAPAT,
	      x, 0);
}

void ukazpoz()
{
  wpoz1 = XCreateSimpleWindow(display, win,
			      0, VYSKAW-vpp, SIRKAW, vpp, 0,
			      BlackPixel(display,screen),
			      BlackPixel(display,screen));

  wpoz2 = XCreateSimpleWindow(display, win,
			      0, VYSKAW-2*vpp, SIRKAW, vpp, 0,
			      BlackPixel(display,screen),
			      BlackPixel(display,screen));

  XSetWindowBackgroundPixmap(display, wpoz1, pp);
  XSetWindowBackgroundPixmap(display, wpoz2, pp);
  XMapWindow(display, wpoz1);
  XMapWindow(display, wpoz2);

  posunutip = vpp;
}

void vytvorpoz()
{
  initpoz();
  ukazpoz();
  vyrobpatra(wpoz1);
  vyrobpatra(wpoz2);
}

void restartpoz()
{
  int i;

  freepatra();
  for(i=0; i<pocetpat2; i++){
    XFreePixmap(display, pat2[i].barvy);
    XFreePixmap(display, pat2[i].akanal);
  }
  XDestroySubwindows(display, wpoz1);
  XDestroySubwindows(display, wpoz2);

  XMoveWindow(display, wpoz1, 0, VYSKAW-vpp);
  XMoveWindow(display, wpoz2, 0, VYSKAW-2*vpp);
  posunutip = vpp;

  vyrobpatra(wpoz1);
  vyrobpatra(wpoz2);
}

posunpoz(int okolik)
{
  Window wpom;
  int i;

  posunutip-=okolik;

  if(posunutip <= 0){
    wpom = wpoz1;
    wpoz1 = wpoz2;
    wpoz2 = wpom;

    posunutip += vpp;
    XDestroySubwindows(display, wpoz2);
    freepatra();
    vyrobpatra(wpoz2);
  }
  i = VYSKAW-posunutip;
  XMoveWindow(display, wpoz1, 0, i);
  XMoveWindow(display, wpoz2, 0, i-vpp);
}

void zmizhr(){
  XUnmapWindow(display, whrac);
}

void ukazhr(){
  XMapWindow(display, whrac);
}

void vytvorhr(Pixmap pxm, int x, int y)
{
  whrac = XCreateSimpleWindow(display, win,
			    x, y, SIRKAHR, VYSKAHR, 0,
			    BlackPixel(display,screen),
			    WhitePixel(display,screen));

  XShapeCombineMask (display, whrac, ShapeBounding,
		     0, 0, shapehr, ShapeSet);

//  XSelectInput(display, whrac, ExposureMask);

  XSetWindowBackgroundPixmap(display, whrac, pxm);

  ukazhr();
}

void zmenvichr(Pixmap pxm, Pixmap shape, int x, int y)
{
  XCopyArea(display, pxm, whrac, gc,
	    0, 0,
	    SIRKAHR, VYSKAHR,
	    0, 0);
  XShapeCombineMask (display, whrac, ShapeBounding,
		     0, 0, shape, ShapeSet);

  XSetWindowBackgroundPixmap(display, whrac, pxm);
  XMoveWindow(display, whrac, x,y);
}

void zmenhr(Pixmap pxm, int x, int y)
{
  XCopyArea(display, pxm, whrac, gc,
	    0, 0,
	    SIRKAHR, VYSKAHR,
	    0, 0);
  XSetWindowBackgroundPixmap(display, whrac, pxm);
  XMoveWindow(display, whrac, x,y);
}

void initimer()
{
  struct timeval ocas, ncas;  

  zastaveno = 0;

  gettimeofday(&ocas, NULL);
  usleep(0);
  gettimeofday(&ncas, NULL);
  uzpozdeni = (ncas.tv_sec-ocas.tv_sec)*1000000+ncas.tv_usec-ocas.tv_usec;

  timer();
}

void udalosti()
{
  XEvent report;

  while (zastaveno || XEventsQueued(display, QueuedAfterReading)){
      XNextEvent(display, &report);

      switch (report.type){

	case ButtonPress:
	  XUnloadFont(display, font_info->fid);
	  XFreeGC(display, gc);
	  XCloseDisplay(display);
	  exit(1);
	  break;

	case KeyPress:
	  if(report.xkey.keycode==0)  printf("doslo to\n");
	  if(report.xkey.keycode==65)  skok = 1;
	  if(report.xkey.keycode==100) vlevo = 1;
	  if(report.xkey.keycode==102) vpravo = 1;
	  if(report.xkey.keycode==33) zastaveno = 1-zastaveno;
//	  printf("%d\n", report.xkey.keycode);
	  break;
	case KeyRelease:
	  if(report.xkey.keycode==65)  skok = 0;
	  if(report.xkey.keycode==100) vlevo = 0;
	  if(report.xkey.keycode==102) vpravo = 0;
	}
    }
}

void vytvorokno(argc, argv)
     int argc;
     char **argv;
{
  XSizeHints size_hints;
  unsigned int border_width = 4;
  char *window_name = "X Icy Tower";
  char *icon_name = "xit";
  Pixmap icon_pixmap;

  win = XCreateSimpleWindow(display, root,
			    0, 0, SIRKAW, VYSKAW, border_width,
			    BlackPixel(display,screen),
			    BlackPixel(display,screen));
  
  icon_pixmap = XCreateBitmapFromData(display, win,
				      icon_bits,
				      icon_width,
				      icon_height);

  size_hints.flags = PPosition | PSize | PMinSize | PMaxSize;
  size_hints.x = 0;
  size_hints.y = 0;
  size_hints.width = SIRKAW;
  size_hints.height = VYSKAW;
  size_hints.min_width = SIRKAW;
  size_hints.min_height = VYSKAW;
  size_hints.max_width = SIRKAW;
  size_hints.max_height = VYSKAW;

  XSetStandardProperties(display, win, window_name, icon_name, icon_pixmap,
			 argv, argc, &size_hints);

  XSelectInput(display, win,
	       KeyPressMask | ButtonPressMask |
	       KeyReleaseMask);

  load_font(&font_info);

  get_GC(win, &gc, font_info);

  XMapWindow(display, win);
}

void initg(argc, argv)
     int argc;
     char **argv;
{
  char *display_name = NULL;

  if ((display=XOpenDisplay(display_name)) == NULL)
    {
      fprintf(stderr,"basicwin: cannot connect to X server %s\n",
	      XDisplayName(display_name));
      exit(-1);
    }
  
  screen = DefaultScreen(display);
  root = RootWindow(display,screen);
  depth = DefaultDepth(display,screen);
//  colormap = DefaultColormap(display, screen);
  vlevo = 0; vpravo = 0; skok = 0;
  pat1 = patra1;
  pat2 = patra2;
}

get_GC(win, gc, font_info)
     Window win;
     GC *gc;
     XFontStruct *font_info;
{
  unsigned long valuemask = 0;
  XGCValues values;
  unsigned int line_width = 1;
  int line_style = LineSolid; /*LineOnOffDash;*/
  int cap_style = CapButt;
  int join_style = JoinMiter;
  int dash_offset = 0;
  static char dash_list[] = {20, 40};
  int list_length = sizeof(dash_list);

*gc = XCreateGC(display, win, valuemask, &values);

XSetFont(display, *gc, font_info->fid);

XSetForeground(display, *gc, BlackPixel(display,screen));

XSetLineAttributes(display, *gc, line_width, line_style, cap_style, join_style);

XSetDashes(display, *gc, dash_offset, dash_list, list_length);
}

load_font(font_info)
XFontStruct **font_info;
{
  char *fontname = "9x15";
  
  if ((*font_info=XLoadQueryFont(display,fontname)) == NULL)
    {
      printf("stderr, basicwin: cannot open 9x15 font\n");
      exit(-1);
    }
}
